%define scm_version 1.0.1
%define scm_rev 4

%define unmangled_version %{scm_version}
%if "%{?_sha1:1}" == ""
	%define _sha1 ""
%endif
%if "%{?_branch:1}" == ""
	%define _branch "master"
%endif

%define dist .mlnx

Name:	nvme-snap
Version:	%{scm_version}
Release:	%{scm_rev}%{?dist}
Summary:	Mellanox Device emulation SDK and NVME controller emulation

License:	Proprietary
URL:	https://github.com/Mellanox/nvmx
Source0:	%{name}-%{version}.tar.gz
Source2:	%{name}-googletest-%{version}.tar.gz

BuildRequires:	automake autoconf make gcc
# BuildRequires: rdma-core-devel >= 23.0-1
# Requires:	rdma-core >= 23.0-1
# Requires:	nvmx-fw >= 18.25.0310
# Requires:	kernel >= 4.20.5-1
Requires:	psmisc >= 22.20
Obsoletes:  nvmx

%description
git branch %{_branch}, sha1 %{_sha1}


%prep
%setup -q
tar xf %{SOURCE2}

%build
# ./autogen.sh
rm -rf autom4te.cache
# hack to force backward compatibility with the libtool
rm -f m4/libtool.m4 m4/lt*
autoreconf -v --force --install || exit 1
rm -rf autom4te.cache

%configure --sysconfdir=/etc/nvme_snap
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%{_datarootdir}/nvmx/tests
%make_install
systemd_dir=${RPM_BUILD_ROOT}%{_prefix}/lib/systemd/system/
mkdir -p ${systemd_dir} ${RPM_BUILD_ROOT}%{_sbindir} ${RPM_BUILD_ROOT}%{_sysconfdir}/default
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/nvme_snap/
install -m 644 ./scripts/nvme_snap@.service ${systemd_dir}
install -m 644 ./scripts/nvme_snap-default.sh ${RPM_BUILD_ROOT}%{_sysconfdir}/default/nvme_snap
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/udev/rules.d/
install -m 644 ./scripts/92-nvme-snap.rules ${RPM_BUILD_ROOT}%{_sysconfdir}/udev/rules.d/
install -m 755 ./scripts/nvme_snap_run_ctrl.sh ${RPM_BUILD_ROOT}%{_sbindir}
install -m 755 ./scripts/nvme_snap_helper.sh ${RPM_BUILD_ROOT}%{_sbindir}
install -m 755 ./scripts/mlxconfig_emulation.py ${RPM_BUILD_ROOT}%{_sbindir}
install -m 644 ./src/json/dummy*.json ${RPM_BUILD_ROOT}%{_sysconfdir}/nvme_snap/
mkdir -p ${RPM_BUILD_ROOT}%{_var}/log/nvme_snap/
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/
install -m 644 ./scripts/nvme_snap ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
cp googletest/LICENSE LICENSE-googletest
install -m 755 ./src/mlx_device_emulation ${RPM_BUILD_ROOT}%{_sbindir}

# DIRTY HACK to rebuild nvme_controller_emu with debug
# and put it into the same RPM package
make clean
 ops=--enable-debug
./configure $ops
make -j
install -m 755 ./samples/nvme_controller_emu \
     ${RPM_BUILD_ROOT}%{_bindir}/nvme_controller_emu_debug

%files
%defattr(-,root,root)
%{_bindir}/*
%{_sbindir}/*
%{_prefix}/lib/*
%{_libdir}/*
%{_includedir}/nvmx
%{_datarootdir}/nvmx/tests
%{_sysconfdir}/nvme_snap/*
%{_sysconfdir}/udev/rules.d/*
# %config %{_sysconfdir}/mlnx_nvme_snap_config.json
%config(noreplace) %{_sysconfdir}/default/nvme_snap
%dir %{_var}/log/nvme_snap
%config %{_sysconfdir}/logrotate.d/nvme_snap
# %config(noreplace) %{_datarootdir}/nvmx/tests/*

%doc README.md TODO.md LICENSE-Mellanox LICENSE-googletest samples/LICENSE-samples
# FIXME we have Doxygen to generate doc

%post
# install or upgrade
if command -v systemctl > /dev/null
then
  systemctl daemon-reload
else
  # do nothing. We don't support RHEL6 or any other OS/distro w/o systemd
  echo
fi


%changelog
* Thu May 23 2019 Yurii Shestakov <yuriis@mellanox.com> [1.0.1-1]
- Add NS global ID support

* Fri May  3 2019 Yurii Shestakov <yuriis@mellanox.com> [1.0.0-10]
- renamed services and scripts from nvmx to nvme-snap
- added /etc/nvme_snap/dummy-*json configs
- add mlxconfig_emulation.py script to configure NVMe PF

* Wed Mar 27 2019 Yurii Shestakov <yuriis@mellanox.com> [1.0.0-1]
- renamed package to nvme-snap

* Wed Mar 06 2019 Yurii Shestakov <yuriis@mellanox.com> [0.9-35]
- nvmx: added nvmx-debug package with nvme_controller_emu_debug
- removed generation of nvmx-ansible package

* Wed Oct 31 2018 Yurii Shestakov <yuriis@mellanox.com> [0.9-6]
- nvmx: added LICENSE-Mellanox, LICENSE-googletest, LICENSE-samples
- nvmx: added Ansible playbooks
- fixed devx test
- fixed keep-alive issues
- NVME controller: added MDTS as environment variable

* Thu Oct 25 2018 Yurii Shestakov <yuriis@mellanox.com> [0.9-3]
- nvmx: added support of sqe_only and cc_remote modes

* Wed Oct 03 2018 Yurii Shestakov <yuriis@mellanox.com> [0.3]
- Added systemd nvmx.service

* Thu Aug 16 2018 Yurii Shestakov <yuriis@mellanox.com> [0.1]
- created nvmx.spec and build_scripts/build_rpm.sh helper
